//-------------------------------------------------------------------------------------------------+
// Dummy2PosesSender.h
// Send two dummy pose datas to port
//-------------------------------------------------------------------------------------------------+

#ifndef Dummy2PosesSender_H
#define Dummy2PosesSender_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

// Service Consumer stub headers
#include "IIS2Stub.h"

using namespace RTC;
using namespace IIS;


//-------------------------------------------------------------------------------------------------+
// Dummy2PosesSender
//-------------------------------------------------------------------------------------------------+
class Dummy2PosesSender : public RTC::DataFlowComponentBase{
public:
	Dummy2PosesSender(RTC::Manager* manager);
	~Dummy2PosesSender();
	virtual RTC::ReturnCode_t onInitialize();
	virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);
	virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

protected:
	double m_start_x;
	double m_start_y;
	double m_start_heading;
	double m_goal_x;
	double m_goal_y;
	double m_goal_heading;
	int m_continuous_output;
	int m_deactivate_to_stop;

	IIS::TimedPose2D m_start_pose;
	OutPort<IIS::TimedPose2D> m_start_poseOut;
	IIS::TimedPose2DSeq m_goal_pose;
	OutPort<IIS::TimedPose2DSeq> m_goal_poseOut;
};



//-------------------------------------------------------------------------------------------------+
extern "C"
{
  DLL_EXPORT void Dummy2PosesSenderInit(RTC::Manager* manager);
};

#endif // Dummy2PosesSender_H
